{-
Copyright (C) 2013 John Lenz <lenz@math.uic.edu>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
-}

module Handler.Pager (getThreadPagerR) where

import Import
import Prelude (tail)
import Settings
import StaticFiles
import NotmuchCmd
import Data.Maybe (listToMaybe)
import Handler.View
import qualified Data.Text as T
import qualified Data.HashMap.Strict as H
import Text.Blaze (unsafeLazyByteString)
import Data.Aeson (encode)

encodeSearch :: (Route App -> T.Text) -> [SearchResult] -> Html
encodeSearch ur search = unsafeLazyByteString $ encode $ map enc search
  where
    enc s = uncurry H.insert ("url" .= ur (ThreadR $ searchThread s)) (toObj s)
    toObj s = case toJSON s of
                  Object o -> o
                  _ -> error "Search is not an object"

getThreadPagerR :: String -> Handler RepHtml
getThreadPagerR s = defaultLayout $ do
    search <- notmuchSearch s
    ur <- lift getUrlRender
    retags <- extraRetag <$> lift getExtra
    addScript $ StaticR js_jquery_pjax_1_2_0_js
    $(widgetFile "pager")
